# Duo, A crazy eights game.
# Copyright (C) 2009 The Duo developers.
#
# This file is part of Duo.
#
# Duo is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""
TODO
"""

class Option(object):
    def __init__(self, name='', value=None, prompt=''):
        self._name = name
        self._value = value
        self._prompt = prompt

    def _get_name(self):
        return self._name

    name = property(_get_name, None, None, 'The option identifier')

    def _get_value(self):
        return self._value

    def _set_value(self, value):
        self._value = value

    value = property(_get_value, _set_value, None, 'The option current value')

    def _get_prompt(self):
        return self._prompt

    prompt = property(_get_prompt, None, None, 'The question to set the option')

    def __str__(self):
        return self._name + ': ' + str(self._value)

    def __repr__(self):
        return self.__str__()


class OptionSet(dict):
    def __init__(self):
        dict.__init__(self)

    def add_option(self, option):
        self[option.name] = option

    def get_option(self, name):
        return self[name]

    def del_option(self, name):
        self.pop(name)

    def as_pairs(self):
        dict_ = {}
        for option in self.values:
            dict_[option.name] = option.value
        return dict_
